#!/bin/bash

METHOD=$1
PJSON="$(dirname $0)/pjson"

MYSQL="mysql -sN -unetroot -pnetroot -e "

case $METHOD in

queue.isrunning)
  OS_VERSION="$(lsb_release -cs)"
  if ([ $OS_VERSION != "trusty" ] && (systemctl -q is-active queue.service)) || ([ $OS_VERSION = "trusty" ] && [ "$(service queue status | grep 'start/running')" ]) ; then
    echo '1';
  else
    echo '0';
  fi;
  ;;
queue.messages.count)
  QUEUE=$2
  if [ $QUEUE == "loaddict" ]; then
    eval "ls /linuxcash/cash/data/queues/artix.loaddict.cash/ | wc -l"
  else
    eval "mysql -uroot -B -N -e \"SELECT count(messageid) FROM queues.message where type = '$QUEUE';\"";
  fi
  ;;
queue.messages.overlimit_types)
  # Формируем список типов сообщений, который нужно исключить
  EXCEPT=""
  if [ "${*:3}" ] ; then
    ARGS="'$3'"
    for ARG in ${*:4} ; do ARGS="$ARGS, '$ARG'"; done
    EXCEPT="WHERE NOT type IN ($ARGS)"
  fi

  TYPES=`mysql -uroot -B -N -e "SELECT type FROM queues.message $EXCEPT GROUP BY type HAVING COUNT(*) >= $2"`
  RESULT=""
  for LINE in $TYPES; do [ $RESULT ] && RESULT="$RESULT, $LINE" || RESULT="$LINE"; done
  echo $RESULT
  ;;
esac
